#!/bin/bash
## BEGIN INIT INFO
# Provides: Jsbin
# Required-Start: $network $syslog
# Required-Stop: $network $syslog
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: Collaborative JavaScript Debugging App
# Description: JS Bin is an open source collaborative web development debugging tool.
### END INIT INFO
USER=<<username>>
PATH=/sbin:/usr/sbin:/bin:/usr/bin:/usr/local/bin
DESC="JSBIN"
NAME=jsbin
APP_PATH=<<jsbin_path>>
DAEMON=${APP_PATH}/bin/jsbin
DAEMON_ARGS=""
PIDPATH=/var/opt/${NAME}
PIDFILE=${PIDPATH}/run/$NAME.pid
SCRIPTNAME=/etc/init.d/${NAME}
export NODE_ENV=production
export PORT=<<jsbin listen port>>
export JSBIN_CONFIG=${APP_PATH}/config.local.json
VERBOSE=yes
. /etc/rc.d/init.d/functions
#
# Function that starts the daemon/service
#
do_start()
{
# Set up folder structure
mkdir -p $PIDPATH
mkdir -p $PIDPATH/run
chown -R $USER:$USER ${PIDPATH}
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
/usr/local/bin/start-stop-daemon --start --quiet \
--chuid $USER:$USER --chdir $APP_PATH --background \
--name $NAME --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
|| return 1
/usr/local/bin/start-stop-daemon --start --quiet \
--chuid $USER:$USER --chdir $APP_PATH --background \
--name $NAME --make-pidfile --pidfile $PIDFILE --exec $DAEMON -- $DAEMON_ARGS \
|| return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one. As a last resort, sleep for some time.
}
#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
/usr/local/bin/start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 \
--pidfile $PIDFILE
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.
/usr/local/bin/start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 \
--exec $DAEMON --pidfile $PIDFILE
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
}
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
/usr/local/bin/start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE \
--name $NAME
return 0
}
case "$1" in
start)
[ "$VERBOSE" != no ] && echo "Starting $DESC" "$NAME"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] && echo 0 ;;
2) [ "$VERBOSE" != no ] && echo 1 ;;
esac
;;
stop)
[ "$VERBOSE" != no ] && echo "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] && echo 0 ;;
2) [ "$VERBOSE" != no ] && echo 1 ;;
esac
;;
status)
#status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
[ -f "$PIDFILE" ] && echo "jsbin is starting..."
RETVAL=$?
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave 'force-reload' as an alias for 'restart'.
#
#log_daemon_msg "Reloading $DESC" "$NAME"
#do_reload
#log_end_msg $?
#;;
restart|force-reload)
#
# If the "reload" option is implemented then remove the
# 'force-reload' alias
#
echo "Restarting $DESC" "$NAME"
do_stop
case "$?" in
0|1)
do_start
do_start
case "$?" in
0) echo 0 ;;
1) echo 1 ;; # Old process is still running
*) echo 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
echo 1
;;
esac
;;
*)
#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
echo "Usage: $SCRIPTNAME {start|stop|status|restart}" >&2
exit 3
;;
esac
: